# User Documentation

* [Intro to VisiData tutorial](https://jsvine.github.io/intro-to-visidata/) by [Jeremy Singer-Vine](https://www.jsvine.com/)
* [quick reference guide](/man)
    * comprehensive overview of all available commands and options
    * also available as a manpage via `man vd` and from inside VisiData with `Ctrl+H`
* [keyboard layout of commands](/docs/kblayout)

###### 'How to' recipes

* [Loading Data](/docs/loading)
    * How to specify a source
    * How to load any source supported by pandas
    * How to open an R data frame with VisiData
    * How to load multiple datasets simultaneously
    * How to access other loaded or derived sheets
    * How to convert a dataset from one supported filetype into another
* [Navigation](/docs/navigate)
    * How to rapidly scroll through a sheet
    * How to search within a sheet
    * How to move between sheets
* [Rows](/docs/rows)
    * How to perform operations on a subset of rows
    * How to filter rows
    * How to filter a random subset of rows
    * How to move, copy and remove rows
    * How to sort rows
* [Columns](/docs/columns)
    * How to manipulate columns
    * How to hide (remove) and unhide columns
    * How to specify column types
    * How to split a column
    * How to create derivative columns
    * How to configure multiple columns
* [Editing contents](/docs/edit)
    * How to edit cells
    * How to rename columns
* [Grouping data and descriptive statistics](/docs/group)
    * How to set statistical aggregators
    * How to create a pivot table
    * How to create a frequency chart
    * How to calculate descriptive statistics
    * How to filter for grouped or described rows
* [Creating sheets, rows and columns](/docs/crud)
    * How to configure the cursor to move right after a successful edit
    * How to set up a sheet for data collection
    * How to add a new blank column
    * How to fill a column with a range of numbers
* [Combining datasets](/docs/join)
    * How to perform a join
    * How to append two datasets
* [Drawing graphs](/docs/graph)
    * How to graph a single column
    * How to graph multiple columns
    * How to interact with graphs
* [How to save and replay a VisiData session](/docs/save-restore)
* [Customizing VisiData](/docs/customize)
    * How to configure VisiData (user)
    * How to configure VisiData (dev)
    * How to have configurations persist
    * How to configure commands

# For developers

VisiData can interact with data from any source or in any format.

* [guide to contributing](/contributing)
* [how to develop a loader](/docs/loaders)
* [viewtsv annotated](/docs/viewtsv)
* [async](/docs/async)
* [graphics reference](/docs/graphics)

